#include <stdio.h>
#define nodos 4
#define infinito 999


extern int TRACE;
extern int YES;
extern int NO;
extern float clocktime;
extern int connectcosts[nodos][nodos];

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int contador;
  int mincost[nodos];    /* min cost to node 0 ... 3 */
  }a;

struct distance_table 
{
  int costs[nodos][nodos];
} dt3;

/* students to write the following two routines, and maybe some others */
int min_distancia3[nodos]={infinito,infinito,infinito,infinito};

int calcula_min3()
{
	int dest, via, cambio = 0;
	int mini[4];

	for (dest=0; dest<4; dest++) {
		mini[dest] = dt3.costs[dest][0];
		for (via=1; via<4; via++) {
			if (mini[dest] > dt3.costs[dest][via])
				mini[dest] = dt3.costs[dest][via];
		}
		if (mini[dest] != connectcosts[3][dest] ) {
			connectcosts[3][dest] = mini[dest];
			cambio =1;
		}
	}
	return cambio;
}


void envia_vecinos3()
{
	int dest;
	struct rtpkt packet;

	packet.sourceid = 3;
	for (dest=0; dest<4; dest++) 
		packet.mincost[dest] = connectcosts[3][dest];

	packet.destid=0;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 3 envia paquete al nodo 0 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);
	packet.destid=2;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 3 envia paquete al nodo 2 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);
	printf("\n");

}

void rtinit3(void) 
{
	int dest,via;
	printf("En el tiempo t=%.3f, rtinit3() es llamado. \n", clocktime);
	for (dest=0; dest<4; dest++)
		for (via=0; via<4; via++) {
			if (dest==via)
				dt3.costs[dest][via] = connectcosts[3][dest];
			else
				dt3.costs[dest][via] = infinito;
		}
		
	for (dest=0; dest<4; dest++) 		
		min_distancia3[dest]=connectcosts[3][dest];
	printdt3(&dt3);
	tolayer2();
	envia_vecinos3();

}

void rtupdate3(rcvdpkt)
  struct rtpkt *rcvdpkt;
{
	int dest,via;
	via=rcvdpkt->sourceid;
	printf("En el tiempo t=%.3f, rtupdate3() es llamado. Nodo3 recibe paquete del nodo %d\n",
		clocktime, via);

	for ( dest= 0; dest<4; dest++) {
		dt3.costs[dest][via] = connectcosts[3][via] + rcvdpkt->mincost[dest];
		if (dt3.costs[dest][via] > infinito)
			dt3.costs[dest][via]= infinito;
	}
	printdt3(&dt3);			
	if (calcula_min3() == 1)
		envia_vecinos3();
}

printdt3(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D3 |    0     1     2 \n");
  printf("  ----|----------------------------- \n");
  printf("     0|  %3d   %3d   %3d\n",dtptr->costs[0][0],
	 dtptr->costs[0][1],dtptr->costs[0][2]);
  printf("dest 1|  %3d   %3d   %3d\n",dtptr->costs[1][0],
	 dtptr->costs[1][1],dtptr->costs[1][2]);
  printf("     2|  %3d   %3d   %3d\n",dtptr->costs[2][0],
	 dtptr->costs[2][1],dtptr->costs[2][2]);
 
}
